# CBpanel "Settings" plugin

name = "Settings"
description = "Configure Panel"

### -- App ---
App_name="CB Panel"
App_version="0.1"
App_authors=["David Art [a.k.a] ADcomp (programmer)"]
App_translator_credits=""
App_website="""http://www.ad-comp.be/
http://crunchbanglinux.org/"""
### -- App ---

import CBpanel, gtk, os

class Settings(CBpanel.PopupWindow):
    def __init__(self, panel):
        CBpanel.PopupWindow.__init__(self, panel, 3, gtk.WINDOW_TOPLEVEL)
        self.set_type_hint(gtk.gdk.WINDOW_TYPE_HINT_NORMAL)

        self.panel = panel

        mainbox = gtk.HBox(False, 4)
        mainbox.set_border_width(4)
        self.add(mainbox)

        ## Settings ##
        btn = gtk.Button()
        btn.set_relief(gtk.RELIEF_NONE)
        btn.set_border_width(0)
        btn.set_focus_on_click(False)
        btn.set_property('can-focus', False)
        btn.connect("clicked", self.show_settings)
        box = gtk.HBox(False, 2)
        btn.add(box)
        img = panel.get_image_from_icon_name('preferences-other')
        box.add(img)
        label = gtk.Label()
        panel.update_font(self, label)
        label.set_alignment(0.5, 0.5)
        label.set_markup("<span weight=\"bold\">Preferences</span>")
        label.show()
        box.add(label)
        mainbox.add(btn)

        ## About_dialog ##
        btn = gtk.Button()
        btn.set_relief(gtk.RELIEF_NONE)
        btn.set_border_width(0)
        btn.set_focus_on_click(False)
        btn.set_property('can-focus', False)
        btn.connect("clicked", self.show_about_dialog)
        box = gtk.HBox(False, 2)
        btn.add(box)
        img = panel.get_image_from_icon_name('help-about')
        box.add(img)
        label = gtk.Label()
        panel.update_font(self, label)
        label.set_alignment(0.5, 0.5)
        label.set_markup("<span weight=\"bold\">about</span>")
        label.show()
        box.add(label)
        mainbox.add(btn)

        ## Main_quit ##
        btn = gtk.Button()
        btn.set_relief(gtk.RELIEF_NONE)
        btn.set_border_width(0)
        btn.set_focus_on_click(False)
        btn.set_property('can-focus', False)
        btn.connect("clicked", panel.doquit)
        box = gtk.HBox(False, 2)
        btn.add(box)
        img = panel.get_image_from_icon_name('application-exit')
        box.add(img)
        label = gtk.Label()
        panel.update_font(self, label)
        label.set_alignment(0.5, 0.5)
        label.set_markup("<span weight=\"bold\">Quit</span>")
        label.show()
        box.add(label)
        mainbox.add(btn)

        ## Logout ##
        btn = gtk.Button()
        btn.set_relief(gtk.RELIEF_NONE)
        btn.set_border_width(0)
        btn.set_focus_on_click(False)
        btn.set_property('can-focus', False)
        btn.connect("clicked", self.onLogout )
        box = gtk.HBox(False, 2)
        btn.add(box)
        img = panel.get_image_from_icon_name('system-log-out')
        box.add(img)
        label = gtk.Label()
        panel.update_font(self, label)
        label.set_alignment(0.5, 0.5)
        label.set_markup("<span weight=\"bold\">Logout</span>")
        label.show()
        box.add(label)
        mainbox.add(btn)

        mainbox.show_all()

    def onLogout(self, btn):
        self.toggle()
        os.spawnl(os.P_NOWAIT, "/bin/sh", "/bin/sh", "-c", 'oblogout')

    def show_settings(self, widget=None, data=None):
        self.toggle()
        #~ message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_NONE, "Not yet :(\nBut soon ..")
        #~ message.add_button(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE)
        #~ resp = message.run()
        #~ if resp == gtk.RESPONSE_CLOSE:
            #~ message.destroy()
        pid = os.getpid()
        os.system("echo %s > /tmp/cbpanel.pid &" % pid)
        os.system("./cbpanel-conf &")

    def show_about_dialog(self, widget=None, data=None):
        """ Show About Dialog """
        dlg = gtk.AboutDialog()
        dlg.set_version(App_version)
        dlg.set_name(App_name)
        dlg.set_position(gtk.WIN_POS_CENTER)
        pixbuf = gtk.gdk.pixbuf_new_from_file('CBpanel/images/cbpanel.png')
        dlg.set_logo(pixbuf)
        # load GPL text file
        gpl = ""
        try:
            h = open('gpl.txt','r')
            s = h.readlines()
            for line in s:
                gpl += line
            h.close()
        except IOError, err:
            print "IO Error %s" % err
        except:
            print "Unexpexted error"

        dlg.set_license(gpl)
        dlg.set_authors(App_authors)
        dlg.set_translator_credits(App_translator_credits)
        dlg.set_website(App_website)

        ###  TODO / Set comments ##
        dlg.set_comments(None)
        ###

        def close(w, res):
            if res == gtk.RESPONSE_CANCEL:
                w.hide()
        dlg.connect("response", close)
        dlg.show()
        self.toggle()

class Plugin(CBpanel.Plugin):
    def __init__(self, panel, settings):
        CBpanel.Plugin.__init__(self, panel, settings)

        self.settings = Settings(panel)
        btn = gtk.ToggleButton()
        btn.set_name("EdgeButton")
        btn.connect("toggled", self.settings.toggle)
        btn.set_relief(gtk.RELIEF_NONE)
        btn.set_border_width(0)
        btn.set_focus_on_click(False)
        btn.set_property('can-focus', False)
        self.add(btn)

        img = panel.get_image_from_icon_name('preferences-desktop')
        btn.add(img)
        self.show_all()
